\ FILENAME    : config.frt
\ CONTENT     : Contains all the fudge factors to optimize the program
\ LANGUAGE    : tForth
\ PROJECT     : hcc primes
\ CATEGORY    : EXAMPLE
\ AUTHOR      :  AH 911108
\ LAST CHANGE :  AH 930410 #Proportionlog eliminated
\ LAST CHANGE :  AH 930410 #ProportPrPo was too small
\ LAST CHANGE :  AH 911119 PBselect added, #SmallPrimesLimit added

\ The following defines the number of primes contained in the bit table
\ For a 32 bit processor multiply by 32.
\ The number of primes is related to the maximum prime MaxP
#40 =: MaxB            \ Length in CELLs of a bit array

\ Guess : for each prime there are two powers in the PrimeBase
#4 =: #ProportPrPo

\ >> This may no longer be applicable to the new Vnumber system. <<
\ We want to handle 100 digit numbers, Maxv =20 allows squaring
#20 =: MaxV            \ Length in CELLs of Vnumber


\ Number of times a number is tested by Rabbin before the conclusion
\ prime is definitive
5 =: #RabbinTries

\ All small primes up to #SmallPrimesLimit are tested
\ as a possible divider before sieving
\ After initial testing make this large
DEVELOPMENT [IF] 900
          [ELSE] 100000
          [THEN] =: #SmallPrimesLimit

\ How sharp is our selection, larger is sharper.
\ Fixed point less 3 digits . 1 is normal
 1200 =: #sharp

\ For a number withless than PBselectCrit1 we use a primebase
\ such that there are PbSelextBase primes in it and so on.
\ Must be in ascending order.
\ The last one should be a stopper!!
\ 10000 bits i.e 3000 decimal digits.
CREATE PBSelect
\ 30  =: PBSelectCrit  30  =: PBSelectBase
30  , 20  ,
40 ,  40 ,
50  , 60  ,
60 , 90 ,
70 , 110 ,
80  , 140 ,
100 , 190 ,
120 , 240 ,
240 , 560 ,
480 , 1000 ,
10000 , 1200 ,
