/*
 * LANGUAGE    : ANSI FORTH
 * PROJECT     : Factoring
 * CATEGORY    : Alternative (graphic) PrintSolution
 * AUTHOR      : Marcel Hendrix November 17, 1991
 * LAST CHANGE : 911122 AH line in the Color of the transputer
 * LAST CHANGE : 00:50:18  November 18, 1991, Marcel Hendrix
 */



                  ?UNDEF -graphics [IF] INCLUDE graphics.frt
                                 [THEN]



        REVISION -gsolution " GPrintSolution      Version 1.00 "

        PRIVATES




:ABOUT
        CR ."  LINEDRAW-BITMAP shows a bit array as rows of colored dots."
        CR
        CR ."  Call INIT-GRAPHICS before using this word." ;



#3000 =: max-linesize   PRIVATE         -- > MaxB CELLS

CREATE bitbuffer        PRIVATE         max-linesize ALLOT


VALUE XTriangle     #20     TO XTriangle        -- center bit map on display
VALUE YTriangle     #20     TO YTriangle

VALUE bgcolor   yellow  TO bgcolor      -- background color VGA/EGA
\ VALUE bgcolor blue    TO bgcolor      -- background color Hercules (visible!)


        bgcolor 1 = [IF] .( Adjusting for Hercules...) [THEN]


: expand>bytes          \ <addr> <bit count> --- <address> <byte count>
        bitbuffer max-linesize ERASE
        SWAP LOCAL bits
        DUP
        0 ?DO
             bits I TestBit IF
               bgcolor
             ELSE
               black
             ENDIF
             I bitbuffer +  XTriangle +  C!
         LOOP
        bitbuffer  SWAP XTriangle + ; PRIVATE


\ Show a horizontal line at position l in the triangle, with length l
\ and color (as yet background)

: GShowSolution                        \ l --- <>
        >S
        XTriangle YTriangle S +         \ Start point
        XTriangle S> + OVER             \ End point
        bgcolor DRAW-LINE
;


VALUE OldArrow PRIVATE

: (GPutArrow)                           \ <y> <color> --- <>
                            LOCAL color
                    YTriangle + LOCAL y
        Xmax 2 3 */ XTriangle + LOCAL Xm
        Xm #30 - y   Xm   5 -  y       color  DRAW-LINE
        Xm #30 - y   Xm #20 -  y #5 +  color  DRAW-LINE
        Xm #30 - y   Xm #20 -  y #5 -  color  DRAW-LINE ; PRIVATE

\ Put an arrow at absolute position y , at about 2/3 of the screen
: GPutArrow ( y -- )
        OldArrow black (GPutArrow)
        DUP TO OldArrow
        bgcolor (GPutArrow) ;



: INIT-GRAPHICS
        TRUE SELECT-HIRES               \ choose maximum resolution
        GRAPHICS ;                \ plot 1 pixel per byte


        DEPRIVE
\       .HELP CR

                                (* End of File *
